Index: src/Fl_mac.cxx
===================================================================
--- src/Fl_mac.cxx	(revision 5492)
+++ src/Fl_mac.cxx	(working copy)
@@ -1256,8 +1256,24 @@
 
 
 /**
- * initialize the Mac toolboxes and set the default menubar
+ * initialize the Mac toolboxes, dock status, and set the default menubar
  */
+
+#ifndef MAC_OS_X_VERSION_10_3
+extern "C" {
+typedef struct CPSProcessSerNum
+{
+  UInt32 lo; 
+  UInt32 hi;
+} CPSProcessSerNum;
+ 
+extern OSErr CPSGetCurrentProcess(CPSProcessSerNum *psn);
+extern OSErr CPSEnableForegroundOperation(CPSProcessSerNum *psn, UInt32 _arg2,
+    UInt32 _arg3, UInt32 _arg4, UInt32 _arg5);
+extern OSErr CPSSetFrontProcess(CPSProcessSerNum *psn);
+}
+#endif
+
 void fl_open_display() {
   static char beenHereDoneThat = 0;
   if ( !beenHereDoneThat )  {
@@ -1276,6 +1292,20 @@
     ClearMenuBar();
     AppendResMenu( GetMenuHandle( 1 ), 'DRVR' );
     DrawMenuBar();
+
+    // bring the application into foreground without a 'CARB' resource
+#ifdef MAC_OS_X_VERSION_10_3
+    // newer supported API
+    ProcessSerialNumber psn = { 0, kCurrentProcess };
+    if( !TransformProcessType( &psn, kProcessTransformToForegroundApplication ) )
+      SetFrontProcess( &psn );
+#else
+    // undocumented API
+    CPSProcessSerNum psn;
+    if( !CPSGetCurrentProcess( &psn ) &&
+        !CPSEnableForegroundOperation( &psn, 0x03, 0x3C, 0x2C, 0x1103 ) )
+      CPSSetFrontProcess( &psn );
+#endif
   }
 }
 
